/** @file
 * @brief SerializeServiceContainer class implementation. This class contains Service objects in a list for serialization.
 *
 *
 *
 * @copyright Intra2net AG
 * @license GPLv2
*/

#include "serializeservicecontainer.h"

#include <boost/serialization/list.hpp>

SerializeServiceContainer::SerializeServiceContainer()
{
}


SerializeServiceContainer::~SerializeServiceContainer()
{
}

/**
 * Serialize function needed by boost/serialization to define which members should be stored as the object state.
 * In this case the STL list of Service pointers will be serialized.
 * @param ar Archive
 * @param version Version
 */
template<class Archive>
void SerializeServiceContainer::serialize(Archive & ar, const unsigned int version)
{
    ar & ContainingServices;
}


void SerializeServiceContainer::add_service(Service::Ptr service)
{
    ContainingServices.push_back(service);
}


std::list<Service::Ptr> SerializeServiceContainer::get_containing_services() const
{
    return ContainingServices;
}
